//
// Created by Administrator on 2019/3/15.
//

#ifndef WORKSPACE_MIN_SYSTEM_H
#define WORKSPACE_MIN_SYSTEM_H

#include <boost/serialization/singleton.hpp>
#include <thread>
#include "zloop.h"
struct task;
struct config_file;

class min_system: zloop<task*>
{
public:
    min_system();
    ~min_system(){};

    void initSystem(config_file * config);
private:
    void run();
    //定时时间处理 每分钟
    void on_time();

    //定时重新加载相关数据
    void on_timer_load();
private:
    std::unique_ptr<std::thread> m_thread;
    // 上传加载时间
    time_t m_lastTimer;
    // 间隔多久加载一次 (秒)
    int m_interval_time;
};

//单件相关定义
typedef boost::serialization::singleton<min_system> singleton_min_system ;
#define s_min_system singleton_min_system::get_mutable_instance()

#endif //WORKSPACE_MIN_SYSTEM_H
